###外观模式
**门面模式是几乎所有JavaScript库的核心原则**

子系统中的一组接口提供一个一致的界面，门面模式定义了一个高层接口，这个接口使得这一子系统更加容易使用，简单的说这是一种组织性的模式，它可以用来修改类和对象的接口，使其更便于使用。  
门面模式的两个作用：  
>1.简化类的接口；  
>2.消除类与使用它的客户代码之间的耦合。  
  
外观模式并不是适配器模式，适配器模式是一种包装器，用来对接口进行适配以便在不兼容系统中使用它。而创建外观元素则是图个方便。它并不用于达到需要特定接口的客户系统打交道这个目的，而是用于提供一个简化的接口。<br />
<br />
<a href="https://github.com/wchaowu/javascript-code/blob/master/JavaScript-Design-Patterns/The-Facade-Pattern/2%20-%20Facades%20as%20convenience%20methods.js">
一个纯粹形式化的例子
</a>
<br />
示例：
<a href="https://github.com/wchaowu/javascript-code/blob/master/JavaScript-Design-Patterns/The-Facade-Pattern/2%20-%20Facades%20as%20convenience%20methods.js">
设置HTML元素的样式
</a>
<br />
示例：
<a href="https://github.com/wchaowu/javascript-code/blob/master/JavaScript-Design-Patterns/The-Facade-Pattern/4%20-%20Creating%20an%20event%20utility.js">
设计一个事件工具
</a>
<br />
2.1、实现外观模式的一般步骤：<br />
找准自己的应用程序中感觉适合使用门面方法的地方后，就可以着手加入便利方法了。这些函数的名称应经仔细考虑，与它们的用途要相称。对于那种由几个函数组合而成的函数，一个简单的办法就是把相关函数的名称串联成一个函数名，并采用camel大写规范，或者也可以使用thisFunctionAndThatFunction这种形式。<br />
处理浏览器API的不一致性属于另一种情况，此时要做的就是把分支代码放在新创建的门面函数中，辅以对象检查或者浏览器嗅探等技术。<br />
2.2、外观模式的适用场合：<br />
判断是否应该应用外观模式的关键在于辨认那些反复成组出线的代码。如果函数b出现在函数a之后这种情况经常出现，那么也许你应该考虑添加一个把这两个函数组合起来的外观函数。<br />
另一种情况是应对Javascript内置函数在不同浏览器中不同表现。最好的解决办法就是把这些差异抽取到外观方法中，它们可以提供一个更一致的接口。<br />
2.3、外观模式之利：<br />
使用外观模式的目的就是要让程序员过的更轻松一些，编写一次组合代码，然后就可以反复使用它，这有助于节省时间和精力。给一些复杂的问题提供一个简化接口。<br />
外观方法方便了开发人员，斌共提供过了比较高层的功能，降低对外部代码的依赖程度，为应用系统的开发增加了一些额外的灵活性。通过使用外观模式，可以避免与下层子系统紧密耦合。这样就可以对这个系统进行修改而不会影响到客户代码。<br />
2.4、外观模式之弊：<br />
有时候外观元素也会带来一些不必要的额外负担。在实施一些套路之前应该认真掂量一下其实用性。有时相比一个庞杂的外观函数，其组成函数在力度方面更有吸引力。这是因为外观函数可能常常会执行一些你并不需要的任务。<br />
对于简单的个人网站或少量营销网页来说，仅为工具提示和弹出式窗口这样一点增强行为就导入这个Javascript库可能并不明智。此时考虑只使用少许简单的外观元素而不是一个满是这类东西的库。<br />
外观函数为执行各种复杂任务提供了一个简单的接口，它们使代码更容易维护和理解。它们还能弱化子系统和客户代码的耦合。把经常相伴出现的常用函数组合在一起。这个模式在DOM脚本编程这种需要面对葛洪不一致的浏览器接口的环境中很常用。